#pragma once

#include "Node.h"
#include "Link.h"
#include <vector>

using namespace std;

class Network
{
public:
	Network() {};
	~Network();

	void GetNodeData( int ID, CPoint& point, CString& label );	

	void AddNode( CPoint point );
	void AddLink( int source, int target );
	void RemoveLink( int source, int target );

	BOOL GetLinkFromPoint( CPoint point, 
						   int& startNode, 
						   int& targetNode,
						   double& linkWeight );

	BOOL GetNodeFromPoint( CPoint point );

	BOOL LinkExistsAtPoint( CPoint point );

	void SetNodeData( int node, CString label );
	void SetLinkWeight( int startNode, int targetNode, CString weight );
	void SetLink( CPoint point );
	void PaintNodes();
	void DrawLinks( vector< Link > lset, BOOL IsBlack );
	void SetPwnd( CWnd *pwnd )	{ pWnd = pwnd; }

	BOOL NodeExists( CPoint point, int& nID );
	BOOL LinkExists( int sourceID, int targetID );

	vector<int> GetAdjNodes( int node );
		
	int GetNodeCount() { return (int) nodes.size(); }
	int GetLinkCount() { return (int) links.size(); }

	int GetLinkStartNode( int link )
	{ return ( *( links.begin() + link ) ).sourceNode; }	

	int GetLinkEndNode( int link )
	{ return ( *( links.begin() + link ) ).targetNode; }

	double GetLinkWeight( int link )
	{ return ( *( links.begin() + link ) ).weight; }

	void ColourLinks( vector< Link > &lset, int colour );
	void ResetLinkColours();
	void ResetNetwork()
	{
		nodes.clear();
		links.clear();	
		counter = 1;
	}

	void DrawLine( BOOL NodeHeld, CPoint currMousePoint, CPoint currLinePoint );

public:
	vector< Node > nodes;
	vector< Link > links;
	static int counter;

protected:

	void GetActualNodeCoordinate( int node, 
								  double& x, 
								  double& y );	

	

	CWnd* pWnd;	
};